"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRegistryFolder = getRegistryFolder;
exports.hasWrapper = hasWrapper;
exports.run = run;
exports.setFlags = setFlags;
function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));
  _regenerator = function _regenerator() {
    return data;
  };
  return data;
}
function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };
  return data;
}
function _errors() {
  var data = require("../../errors.js");
  _errors = function _errors() {
    return data;
  };
  return data;
}
function fs() {
  var data = _interopRequireWildcard(require("../../util/fs.js"));
  fs = function fs() {
    return data;
  };
  return data;
}
function _global() {
  var data = require("./global");
  _global = function _global() {
    return data;
  };
  return data;
}
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
var invariant = require('invariant');
var path = require('path');
function getRegistryFolder(_x, _x2) {
  return _getRegistryFolder.apply(this, arguments);
}
function _getRegistryFolder() {
  _getRegistryFolder = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee(config, name) {
    var src, _yield$config$readMan, _registry, registryFolder;
    return _regenerator()["default"].wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          if (!config.modulesFolder) {
            _context.next = 2;
            break;
          }
          return _context.abrupt("return", config.modulesFolder);
        case 2:
          src = path.join(config.linkFolder, name);
          _context.next = 5;
          return config.readManifest(src);
        case 5:
          _yield$config$readMan = _context.sent;
          _registry = _yield$config$readMan._registry;
          invariant(_registry, 'expected registry');
          registryFolder = config.registries[_registry].folder;
          return _context.abrupt("return", path.join(config.cwd, registryFolder));
        case 10:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return _getRegistryFolder.apply(this, arguments);
}
function hasWrapper(commander, args) {
  return true;
}
function setFlags(commander) {
  commander.description('Symlink a package folder during development.');
}
function run(_x3, _x4, _x5, _x6, _x7) {
  return _run.apply(this, arguments);
}
function _run() {
  _run = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee2(config, reporter, commander, flags, args) {
    var _iterator, _step, name, src, folder, dest, manifest, _name, linkLoc, globalBinFolder, binName, binSrc, binSrcLoc, binDestLoc;
    return _regenerator()["default"].wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          if (!(args.length > 0)) {
            _context2.next = 36;
            break;
          }
          _iterator = _createForOfIteratorHelper(args);
          _context2.prev = 2;
          _iterator.s();
        case 4:
          if ((_step = _iterator.n()).done) {
            _context2.next = 26;
            break;
          }
          name = _step.value;
          src = path.join(config.linkFolder, name);
          _context2.next = 9;
          return fs().exists(src);
        case 9:
          if (!_context2.sent) {
            _context2.next = 23;
            break;
          }
          _context2.next = 12;
          return getRegistryFolder(config, name);
        case 12:
          folder = _context2.sent;
          dest = path.join(folder, name);
          _context2.next = 16;
          return fs().unlink(dest);
        case 16:
          _context2.next = 18;
          return fs().mkdirp(path.dirname(dest));
        case 18:
          _context2.next = 20;
          return fs().symlink(src, dest);
        case 20:
          reporter.success(reporter.lang('linkUsing', name));
          _context2.next = 24;
          break;
        case 23:
          throw new (_errors().MessageError)(reporter.lang('linkMissing', name));
        case 24:
          _context2.next = 4;
          break;
        case 26:
          _context2.next = 31;
          break;
        case 28:
          _context2.prev = 28;
          _context2.t0 = _context2["catch"](2);
          _iterator.e(_context2.t0);
        case 31:
          _context2.prev = 31;
          _iterator.f();
          return _context2.finish(31);
        case 34:
          _context2.next = 79;
          break;
        case 36:
          _context2.next = 38;
          return config.readRootManifest();
        case 38:
          manifest = _context2.sent;
          _name = manifest.name;
          if (_name) {
            _context2.next = 42;
            break;
          }
          throw new (_errors().MessageError)(reporter.lang('unknownPackageName'));
        case 42:
          linkLoc = path.join(config.linkFolder, _name);
          _context2.next = 45;
          return fs().exists(linkLoc);
        case 45:
          if (!_context2.sent) {
            _context2.next = 49;
            break;
          }
          reporter.warn(reporter.lang('linkCollision', _name));
          _context2.next = 79;
          break;
        case 49:
          _context2.next = 51;
          return fs().mkdirp(path.dirname(linkLoc));
        case 51:
          _context2.next = 53;
          return fs().symlink(config.cwd, linkLoc);
        case 53:
          if (!manifest.bin) {
            _context2.next = 77;
            break;
          }
          _context2.next = 56;
          return (0, _global().getBinFolder)(config, flags);
        case 56:
          globalBinFolder = _context2.sent;
          _context2.t1 = _regenerator()["default"].keys(manifest.bin);
        case 58:
          if ((_context2.t2 = _context2.t1()).done) {
            _context2.next = 77;
            break;
          }
          binName = _context2.t2.value;
          binSrc = manifest.bin[binName];
          binSrcLoc = path.join(linkLoc, binSrc);
          binDestLoc = path.join(globalBinFolder, binName);
          _context2.next = 65;
          return fs().exists(binDestLoc);
        case 65:
          if (!_context2.sent) {
            _context2.next = 69;
            break;
          }
          reporter.warn(reporter.lang('binLinkCollision', binName));
          _context2.next = 75;
          break;
        case 69:
          if (!(process.platform === 'win32')) {
            _context2.next = 73;
            break;
          }
          ;
          _context2.next = 75;
          break;
        case 73:
          _context2.next = 75;
          return fs().symlink(binSrcLoc, binDestLoc);
        case 75:
          _context2.next = 58;
          break;
        case 77:
          reporter.success(reporter.lang('linkRegistered', _name));
          reporter.info(reporter.lang('linkRegisteredMessage', _name));
        case 79:
        case "end":
          return _context2.stop();
      }
    }, _callee2, null, [[2, 28, 31, 34]]);
  }));
  return _run.apply(this, arguments);
}
//# sourceMappingURL=link.js.map
