"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.examples = void 0;
exports.getName = getName;
exports.run = exports.hasWrapper = void 0;
exports.setFlags = setFlags;
function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));
  _regenerator = function _regenerator() {
    return data;
  };
  return data;
}
function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };
  return data;
}
function _buildSubCommands2() {
  var data = _interopRequireDefault(require("./_build-sub-commands.js"));
  _buildSubCommands2 = function _buildSubCommands2() {
    return data;
  };
  return data;
}
function _login() {
  var data = require("./login.js");
  _login = function _login() {
    return data;
  };
  return data;
}
function _npmRegistry() {
  var data = _interopRequireDefault(require("../../registries/npm-registry.js"));
  _npmRegistry = function _npmRegistry() {
    return data;
  };
  return data;
}
function _errors() {
  var data = require("../../errors.js");
  _errors = function _errors() {
    return data;
  };
  return data;
}
function _normalizePattern2() {
  var data = require("../../util/normalize-pattern.js");
  _normalizePattern2 = function _normalizePattern2() {
    return data;
  };
  return data;
}
function _validate() {
  var data = require("../../util/normalize-manifest/validate.js");
  _validate = function _validate() {
    return data;
  };
  return data;
}
function getName(_x, _x2) {
  return _getName.apply(this, arguments);
}
function _getName() {
  _getName = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee6(args, config) {
    var name, pkg;
    return _regenerator()["default"].wrap(function _callee6$(_context6) {
      while (1) switch (_context6.prev = _context6.next) {
        case 0:
          name = args.shift();
          if (name) {
            _context6.next = 6;
            break;
          }
          _context6.next = 4;
          return config.readRootManifest();
        case 4:
          pkg = _context6.sent;
          name = pkg.name;
        case 6:
          if (!name) {
            _context6.next = 12;
            break;
          }
          if ((0, _validate().isValidPackageName)(name)) {
            _context6.next = 9;
            break;
          }
          throw new (_errors().MessageError)(config.reporter.lang('invalidPackageName'));
        case 9:
          return _context6.abrupt("return", _npmRegistry()["default"].escapeName(name));
        case 12:
          throw new (_errors().MessageError)(config.reporter.lang('unknownPackageName'));
        case 13:
        case "end":
          return _context6.stop();
      }
    }, _callee6);
  }));
  return _getName.apply(this, arguments);
}
function _list2(_x3, _x4, _x5, _x6) {
  return _list.apply(this, arguments);
}
function _list() {
  _list = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee7(config, reporter, flags, args) {
    var name, tags, _name;
    return _regenerator()["default"].wrap(function _callee7$(_context7) {
      while (1) switch (_context7.prev = _context7.next) {
        case 0:
          _context7.next = 2;
          return getName(args, config);
        case 2:
          name = _context7.sent;
          reporter.step(1, 1, reporter.lang('gettingTags'));
          _context7.next = 6;
          return config.registries.npm.request("-/package/".concat(name, "/dist-tags"));
        case 6:
          tags = _context7.sent;
          if (tags) {
            reporter.info("Package ".concat(name));
            for (_name in tags) {
              reporter.info("".concat(_name, ": ").concat(tags[_name]));
            }
          }
          if (tags) {
            _context7.next = 10;
            break;
          }
          throw new (_errors().MessageError)(reporter.lang('packageNotFoundRegistry', name, 'npm'));
        case 10:
        case "end":
          return _context7.stop();
      }
    }, _callee7);
  }));
  return _list.apply(this, arguments);
}
function _remove2(_x7, _x8, _x9, _x10) {
  return _remove.apply(this, arguments);
}
function _remove() {
  _remove = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee8(config, reporter, flags, args) {
    var name, tag, revoke, result;
    return _regenerator()["default"].wrap(function _callee8$(_context8) {
      while (1) switch (_context8.prev = _context8.next) {
        case 0:
          if (!(args.length !== 2)) {
            _context8.next = 2;
            break;
          }
          return _context8.abrupt("return", false);
        case 2:
          _context8.next = 4;
          return getName(args, config);
        case 4:
          name = _context8.sent;
          tag = args.shift();
          reporter.step(1, 3, reporter.lang('loggingIn'));
          _context8.next = 9;
          return (0, _login().getToken)(config, reporter, name);
        case 9:
          revoke = _context8.sent;
          reporter.step(2, 3, reporter.lang('deletingTags'));
          _context8.next = 13;
          return config.registries.npm.request("-/package/".concat(name, "/dist-tags/").concat(encodeURI(tag)), {
            method: 'DELETE'
          });
        case 13:
          result = _context8.sent;
          if (result === false) {
            reporter.error(reporter.lang('deletedTagFail'));
          } else {
            reporter.success(reporter.lang('deletedTag'));
          }
          reporter.step(3, 3, reporter.lang('revokingToken'));
          _context8.next = 18;
          return revoke();
        case 18:
          if (!(result === false)) {
            _context8.next = 22;
            break;
          }
          throw new Error();
        case 22:
          return _context8.abrupt("return", true);
        case 23:
        case "end":
          return _context8.stop();
      }
    }, _callee8);
  }));
  return _remove.apply(this, arguments);
}
var _buildSubCommands = (0, _buildSubCommands2()["default"])('tag', {
    add: function add(config, reporter, commander, flags, args) {
      return (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee() {
        var _normalizePattern, name, range, hasVersion, tag, revoke, result;
        return _regenerator()["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (!(args.length !== 2)) {
                _context.next = 2;
                break;
              }
              return _context.abrupt("return", false);
            case 2:
              _normalizePattern = (0, _normalizePattern2().normalizePattern)(args.shift()), name = _normalizePattern.name, range = _normalizePattern.range, hasVersion = _normalizePattern.hasVersion;
              if (hasVersion) {
                _context.next = 5;
                break;
              }
              throw new (_errors().MessageError)(reporter.lang('requiredVersionInRange'));
            case 5:
              if ((0, _validate().isValidPackageName)(name)) {
                _context.next = 7;
                break;
              }
              throw new (_errors().MessageError)(reporter.lang('invalidPackageName'));
            case 7:
              tag = args.shift();
              reporter.step(1, 3, reporter.lang('loggingIn'));
              _context.next = 11;
              return (0, _login().getToken)(config, reporter, name);
            case 11:
              revoke = _context.sent;
              reporter.step(2, 3, reporter.lang('creatingTag', tag, range));
              _context.next = 15;
              return config.registries.npm.request("-/package/".concat(_npmRegistry()["default"].escapeName(name), "/dist-tags/").concat(encodeURI(tag)), {
                method: 'PUT',
                body: range
              });
            case 15:
              result = _context.sent;
              if (result != null && result.ok) {
                reporter.success(reporter.lang('createdTag'));
              } else {
                reporter.error(reporter.lang('createdTagFail'));
              }
              reporter.step(3, 3, reporter.lang('revokingToken'));
              _context.next = 20;
              return revoke();
            case 20:
              if (!(result != null && result.ok)) {
                _context.next = 24;
                break;
              }
              return _context.abrupt("return", true);
            case 24:
              throw new Error();
            case 25:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }))();
    },
    rm: function rm(config, reporter, commander, flags, args) {
      return (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee2() {
        return _regenerator()["default"].wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              reporter.warn("`yarn tag rm` is deprecated. Please use `yarn tag remove`.");
              _context2.next = 3;
              return _remove2(config, reporter, flags, args);
            case 3:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      }))();
    },
    remove: function remove(config, reporter, commander, flags, args) {
      return (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee3() {
        return _regenerator()["default"].wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return _remove2(config, reporter, flags, args);
            case 2:
            case "end":
              return _context3.stop();
          }
        }, _callee3);
      }))();
    },
    ls: function ls(config, reporter, commander, flags, args) {
      return (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee4() {
        return _regenerator()["default"].wrap(function _callee4$(_context4) {
          while (1) switch (_context4.prev = _context4.next) {
            case 0:
              reporter.warn("`yarn tag ls` is deprecated. Please use `yarn tag list`.");
              _context4.next = 3;
              return _list2(config, reporter, flags, args);
            case 3:
            case "end":
              return _context4.stop();
          }
        }, _callee4);
      }))();
    },
    list: function list(config, reporter, commander, flags, args) {
      return (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee5() {
        return _regenerator()["default"].wrap(function _callee5$(_context5) {
          while (1) switch (_context5.prev = _context5.next) {
            case 0:
              _context5.next = 2;
              return _list2(config, reporter, flags, args);
            case 2:
            case "end":
              return _context5.stop();
          }
        }, _callee5);
      }))();
    }
  }, ['add <pkg>@<version> [<tag>]', 'remove <pkg> <tag>', 'list [<pkg>]']),
  run = _buildSubCommands.run,
  _setFlags = _buildSubCommands.setFlags,
  hasWrapper = _buildSubCommands.hasWrapper,
  examples = _buildSubCommands.examples;
exports.examples = examples;
exports.hasWrapper = hasWrapper;
exports.run = run;
function setFlags(commander) {
  _setFlags(commander);
  commander.description('Add, remove, or list tags on a package.');
}
//# sourceMappingURL=tag.js.map
