"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
function _classCallCheck2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
  _classCallCheck2 = function _classCallCheck2() {
    return data;
  };
  return data;
}
function _createClass2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
  _createClass2 = function _createClass2() {
    return data;
  };
  return data;
}
function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
  _defineProperty2 = function _defineProperty2() {
    return data;
  };
  return data;
}
var semver = require('semver');

// This isn't really a "proper" constraint resolver. We just return the highest semver
// version in the versions passed that satisfies the input range. This vastly reduces
// the complexity and is very efficient for package resolution.
var PackageConstraintResolver = /*#__PURE__*/function () {
  function PackageConstraintResolver(config, reporter) {
    (0, _classCallCheck2()["default"])(this, PackageConstraintResolver);
    (0, _defineProperty2()["default"])(this, "reporter", void 0);
    (0, _defineProperty2()["default"])(this, "config", void 0);
    this.reporter = reporter;
    this.config = config;
  }
  (0, _createClass2()["default"])(PackageConstraintResolver, [{
    key: "reduce",
    value: function reduce(versions, range) {
      if (range === 'latest') {
        // Usually versions are already ordered and the last one is the latest
        return Promise.resolve(versions[versions.length - 1]);
      } else {
        return Promise.resolve(semver.maxSatisfying(versions, range, this.config.looseSemver));
      }
    }
  }]);
  return PackageConstraintResolver;
}();
exports["default"] = PackageConstraintResolver;
//# sourceMappingURL=package-constraint-resolver.js.map
