"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };
  return data;
}
function _classCallCheck2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
  _classCallCheck2 = function _classCallCheck2() {
    return data;
  };
  return data;
}
function _createClass2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
  _createClass2 = function _createClass2() {
    return data;
  };
  return data;
}
function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
  _defineProperty2 = function _defineProperty2() {
    return data;
  };
  return data;
}
function _misc() {
  var data = require("./util/misc.js");
  _misc = function _misc() {
    return data;
  };
  return data;
}
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
var PackageReference = /*#__PURE__*/function () {
  function PackageReference(request, info, remote) {
    (0, _classCallCheck2()["default"])(this, PackageReference);
    (0, _defineProperty2()["default"])(this, "requests", void 0);
    (0, _defineProperty2()["default"])(this, "lockfile", void 0);
    (0, _defineProperty2()["default"])(this, "config", void 0);
    (0, _defineProperty2()["default"])(this, "isPlugnplay", void 0);
    (0, _defineProperty2()["default"])(this, "level", void 0);
    (0, _defineProperty2()["default"])(this, "name", void 0);
    (0, _defineProperty2()["default"])(this, "version", void 0);
    (0, _defineProperty2()["default"])(this, "uid", void 0);
    (0, _defineProperty2()["default"])(this, "optional", void 0);
    (0, _defineProperty2()["default"])(this, "hint", void 0);
    (0, _defineProperty2()["default"])(this, "ignore", void 0);
    (0, _defineProperty2()["default"])(this, "incompatible", void 0);
    (0, _defineProperty2()["default"])(this, "fresh", void 0);
    (0, _defineProperty2()["default"])(this, "dependencies", void 0);
    (0, _defineProperty2()["default"])(this, "patterns", void 0);
    (0, _defineProperty2()["default"])(this, "permissions", void 0);
    (0, _defineProperty2()["default"])(this, "remote", void 0);
    (0, _defineProperty2()["default"])(this, "registry", void 0);
    (0, _defineProperty2()["default"])(this, "locations", void 0);
    (0, _defineProperty2()["default"])(this, "resolver", void 0);
    this.resolver = request.resolver;
    this.lockfile = request.lockfile;
    this.requests = [];
    this.config = request.config;
    this.hint = request.hint;
    this.isPlugnplay = false;
    this.registry = remote.registry;
    this.version = info.version;
    this.name = info.name;
    this.uid = info._uid;
    this.remote = remote;
    this.dependencies = [];
    this.permissions = {};
    this.patterns = [];
    this.optional = null;
    this.level = Infinity;
    this.ignore = false;
    this.incompatible = false;
    this.fresh = false;
    this.locations = [];
    this.addRequest(request);
  }
  (0, _createClass2()["default"])(PackageReference, [{
    key: "setFresh",
    value: function setFresh(fresh) {
      this.fresh = fresh;
    }
  }, {
    key: "addLocation",
    value: function addLocation(loc) {
      if (this.locations.indexOf(loc) === -1) {
        this.locations.push(loc);
      }
    }
  }, {
    key: "addRequest",
    value: function addRequest(request) {
      this.requests.push(request);
      this.level = Math.min(this.level, request.parentNames.length);
    }
  }, {
    key: "prune",
    value: function prune() {
      var _iterator = _createForOfIteratorHelper(this.patterns),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var selfPattern = _step.value;
          // remove ourselves from the resolver
          this.resolver.removePattern(selfPattern);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }, {
    key: "addDependencies",
    value: function addDependencies(deps) {
      this.dependencies = this.dependencies.concat(deps);
    }
  }, {
    key: "setPermission",
    value: function setPermission(key, val) {
      this.permissions[key] = val;
    }
  }, {
    key: "hasPermission",
    value: function hasPermission(key) {
      if (key in this.permissions) {
        return this.permissions[key];
      } else {
        return false;
      }
    }
  }, {
    key: "addPattern",
    value: function addPattern(pattern, manifest) {
      this.resolver.addPattern(pattern, manifest);
      this.patterns.push(pattern);
      var shrunk = this.lockfile.getLocked(pattern);
      if (shrunk && shrunk.permissions) {
        var _iterator2 = _createForOfIteratorHelper((0, _misc().entries)(shrunk.permissions)),
          _step2;
        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var _step2$value = (0, _slicedToArray2()["default"])(_step2.value, 2),
              _key = _step2$value[0],
              perm = _step2$value[1];
            this.setPermission(_key, perm);
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      }
    }
  }, {
    key: "addOptional",
    value: function addOptional(optional) {
      if (this.optional == null) {
        // optional is uninitialised
        this.optional = optional;
      } else if (!optional) {
        // otherwise, ignore all subsequent optional assignments and only accept ones making
        // this not optional
        this.optional = false;
      }
    }
  }]);
  return PackageReference;
}();
exports["default"] = PackageReference;
//# sourceMappingURL=package-reference.js.map
